// include ftpclient.js
document.write('<script type="text/javascript" src="ftpclient.js"></scr' + 'ipt>'); 

// global variables
var edtUploadControls = new Array();                 // references to FTPClient instances
var edtUploadTransfers = new TransferCollection();   // references to current transfers

// EdtUploadControl class
function EdtUploadControl(controlID) {

	this.id = controlID;

	this.setRemoteHost = function(remoteHost) { this.ftpClient.remoteHost = remoteHost; }
	this.getRemoteHost = function() { return this.ftpClient.remoteHost; }
	this.setUserName = function(userName) { this.ftpClient.userName = userName; }
	this.getUserName = function() { return this.ftpClient.userName; }
	this.setPassword = function(password) { this.ftpClient.password = password; }
	this.getPassword = function() { return this.ftpClient.password; }
	this.setProtocol = function(protocol) { this.ftpClient.protocol = protocol; }
	this.getProtocol = function() { return this.ftpClient.protocol; }
	this.setInitialRemoteDirectory = function(initialRemoteDirectory) { 
		this.ftpClient.initialRemoteDirectory = initialRemoteDirectory; 
	}
	this.getInitialRemoteDirectory = function() { return this.ftpClient.initialRemoteDirectory; }
	this.setButtonText = function(buttonText) { this.button.value = buttonText; }
	this.getButtonText = function() { return this.button.value; }
	this.setLogLevel = function(level) { this.logLevel = level; }
	this.onFileSelected = null;
	this.onFilesUploaded = null;
	this.onClick = null;
	this.render = function() { 
		if (this.container!==undefined) 
			return;
		
		// if no controlID is defined then add the control to the document
		if (this.id===undefined || this.id===null) {
			this.id = "EdtUploadControl" + edtUploadControls.length;
			document.write("<div id='" + this.id + "' class='EdtUploadControl'></div>");
		}
		edtUploadControls[this.id] = this;
		this.container = document.getElementById(this.id);
		this.container.appendChild(this.button);
		this.container.appendChild(this.progressDiv);
	}
	
	// set up FTP client
	this.ftpClient = new FTPClient();
	this.ftpClient.logLevel = "DEBUG";
	this.ftpClient.showSplash = true;
	this.ftpClient.onInitialize = onInitialize;
	this.ftpClient.onConnect = onConnect;
	this.ftpClient.onLocalSize = onLocalSize;
	this.ftpClient.onUploadFile = onUploadFile;
	this.ftpClient.onTransferProgress = onTransferProgress;
	
	// set a global reference to the FTP client
	edtUploadControls[this.ftpClient.id] = this;
	
	// add the button
	this.button = document.createElement("input");
	this.button.type = "button";
	this.button.className = "EdtUploadButton";
	this.button.value = "Upload File";
	this.button.onclick = onButtonClick;
	
	// add progress table (inside a div)
	this.progressDiv = document.createElement("div");
	this.progressDiv.className = "EdtUploadProgressDiv";
	this.progress = document.createElement("table");
	this.progress.className = "EdtUploadProgressTable";
	this.progress.id = "EdtUploadProgressTable" + this.ftpClient.id;
	this.progressDiv.appendChild(this.progress); 
}

function onButtonClick(e) {
	var target = ( document.all ) ? window.event.srcElement : e.target;
	var uploadControl = edtUploadControls[target.parentNode.id];
	if (uploadControl.onClick!==null)
		uploadControl.onClick();
	var ftpClient = uploadControl.ftpClient;
	if (!ftpClient.isInitialized()) {
		ftpClient.initialize("IntegralFTP.jar");
	} else
		promptForFiles(ftpClient);
}

function onInitialize(status) {
	if (status.success) {
		var uploadControl = edtUploadControls[status.ftpClient.id];
		if (uploadControl.logLevel!==undefined)
			uploadControl.ftpClient.setLogLevel(uploadControl.logLevel);
		promptForFiles(status.ftpClient);
	} else
		alert("Could not initialize upload control", status.errorMessage);
}

function onFileSelected(response) {
	try {
		if (response.files===null)
			return;
		var uploadControl = edtUploadControls[response.ftpClient.id];
		if (uploadControl.onFileSelected!==null)
			uploadControl.onFileSelected(uploadControl, response.files);
		if (!response.ftpClient.isConnected()) {
			response.ftpClient.connect(response.files);
		} else {
			getFileSizes(response.ftpClient, response.files);
		}
	} catch (e) {
		alert("Error: " + e);
	}
}

function onConnect(status) {
	if (status.success)
		getFileSizes(status.ftpClient, status.tag);
	else
		alert("Could not connect to server: " + status.errorMessage);
}

function getFileSizes(ftpClient, files) {
	for (var i in files)
		ftpClient.localSize(files[i], files[i]);
}

function onLocalSize(status, remoteFileName, size) {
	uploadFile(status.ftpClient, status.tag, size);
}

function onTransferProgress(status, remoteFileName, byteCount) {
	if (status.success) {
		var transfer = edtUploadTransfers.find(status.taskID);
		if (transfer!==null) {
			setProgress(status.taskID, Math.floor((transfer.offset+byteCount)*100/transfer.size));
		}
	}
}

function onUploadFile(status, remoteFileName) {
	var transfer = edtUploadTransfers.find(status.taskID);
	completeProgressBar(status.ftpClient, status.taskID, status.success, transfer.fileName, status.errorMessage);
	edtUploadTransfers.remove(status.taskID);
	
	var uploadControl = edtUploadControls[status.ftpClient.id];
	if (uploadControl.onFilesUploaded!=null && edtUploadTransfers.length()==0)
		uploadControl.onFilesUploaded();
}

function promptForFiles(ftpClient) {
	ftpClient.promptFile(true, onFileSelected, ftpClient);
}

function uploadFile(ftpClient, path, size) {
	var sep = ftpClient.localSeparator;
	var fileName = path.substr(path.lastIndexOf(sep)+1);
	var taskID = ftpClient.uploadFile(path, fileName, ftpClient.WRITEMODE_OVERWRITE, fileName);
	var progressRow = addProgressBar(ftpClient, taskID, fileName);
	edtUploadTransfers.add(ftpClient, taskID, fileName, path, size, 0, progressRow, false);
}

function addProgressBar(ftpClient, taskID, text) {
	var progressID = "Transfer"+taskID;
	var progressTable = document.getElementById("EdtUploadProgressTable"+ftpClient.id);
	
	if (progressTable===null) {
		return;
	}
	
	var progressRow = progressTable.insertRow(0);
	progressRow.id = progressID + "-row";
	
	var textCell = progressRow.insertCell(0);
	textCell.className = "EdtUploadProgressText";
	textCell.id = progressID + "-text";
	textCell.appendChild(document.createTextNode(text));
	
	var barCell = progressRow.insertCell(1);
	barCell.width = "100%";
	
	var barTable = barCell.appendChild(document.createElement("table"));
	barTable.className = "EdtUploadProgressBar";
	barTable.id = progressID + "-bar";
	
	var barRow = barTable.insertRow(0);
	
	var leftBarCell = barRow.insertCell(0);
	leftBarCell.className = "EdtUploadProgressBarFilled";
	leftBarCell.id = progressID + "-left";
	leftBarCell.style.width = "0%";
	
	var rightBarCell = barRow.insertCell(1);
	rightBarCell.className = "EdtUploadProgressBarUnfilled";
	rightBarCell.id = progressID + "-right";
	rightBarCell.style.width = "100%";
		
	var cancelCell = progressRow.insertCell(2);
	var cancelLink = cancelCell.appendChild(document.createElement("a"));
	cancelLink.id = progressID + "-cancelLink";
	cancelLink.href = "javascript:cancelTransfer(" + ftpClient.id + ", " + taskID + ");";
	
	var cancelImage = cancelLink.appendChild(document.createElement("img"));
	cancelImage.id = progressID + "-cancelImage";
	cancelImage.border = "0px";
	cancelImage.src = "images/stop.png";
	
	return progressRow;
}

function setProgress(taskID, percentage) {
	var progressID = "Transfer" + taskID;
	
	var barTable = document.getElementById(progressID+"-bar");
	if (barTable===null)
		return;
	
	var leftBarCell = document.getElementById(progressID+"-left");
	leftBarCell.style.width = percentage + "%";
	
	var rightBarCell = document.getElementById(progressID+"-right");
	rightBarCell.style.width = (100-percentage) + "%";
}

function completeProgressBar(ftpClient, taskID, success, text, errorMessage) {
	var progressID = "Transfer" + taskID;
	var progressTable = document.getElementById("EdtUploadProgressTable"+ftpClient.id);
	if (progressTable===null)
		return;
		
	var barTable = document.getElementById(progressID+"-bar");
	var progressRow = document.getElementById(progressID + "-row");
	var textCell = document.getElementById(progressID + "-text");
	var progressBar = document.getElementById(progressID + "-left");
	var cancelImage = document.getElementById(progressID + "-cancelImage");
	var cancelLink = document.getElementById(progressID + "-cancelLink");

	// complete progress bar	
	barTable.rows[0].deleteCell(1);
	progressBar.style.width = "100%";
	if (success) {
		cancelImage.src = "images/accept.png";
		cancelLink.href = "javascript:alert(\"Transfer complete.\")";
		progressBar.className = "EdtUploadProgressBarFilled EdtUploadProgressBarSucceeded";
	} else {
		cancelImage.src = "images/exclamation.png";
		var safeErrorMessage = escape(errorMessage.replace(/\\/g,"\\\\"));
		cancelLink.href = "javascript:alert(\"Transfer failed!    " + safeErrorMessage + ".\")";
		progressBar.className = "EdtUploadProgressBarFilled EdtUploadProgressBarFailed";
	}
	
	// change text
	var textNode = textCell.childNodes[0];
	textNode.parentNode.replaceChild(document.createTextNode(text), textNode);
	
	// reorder rows
	var rowIndex = -1;
	var lastActive = -1;
	for (var i=0; i<progressTable.rows.length; i++) {
		var r = progressTable.rows[i];
		if (r.id==progressRow.id)
			rowIndex = i;
		var t = getTaskIDFromRowID(r.id);
		if (edtUploadTransfers.find(t)===null)
			break;
		lastActive = i;
	}
	if (lastActive===rowIndex)
		return;
	var clonedRow = progressRow.cloneNode(true);
	progressTable.deleteRow(rowIndex);
	var newRow = progressTable.insertRow(lastActive);
	newRow.parentNode.replaceChild(clonedRow, newRow);
}

function getTaskIDFromRowID(rowID) {
	var s = rowID.substring("Transfer".length);
	return parseInt(s);
}

function cancelTransfer(clientID, taskID) {
	var transfer = edtUploadTransfers.find(taskID);
	transfer.ftpClient.cancelTransfer(taskID);
}

function TransferCollection() {
	
	this.transfers = new Array();
	
	this.add = function(ftpClient, taskID, fileName, filePath, size, offset, progressRow, viewWhenComplete) {
		this.transfers.push(new TransferInfo(ftpClient, taskID, fileName, filePath, size, offset, progressRow, viewWhenComplete));
	};
	this.remove = function(taskID) {
		var index = this.find(taskID);
		if (index!==null)
			this.transfers.splice(index, 1);
	};
	this.find = function(taskID) {
		for (var i in this.transfers)
			if (this.transfers[i].taskID===taskID)
				return this.transfers[i];
		return null;
	};
	this.length = function() {
		return this.transfers.length;
	}
}

function TransferInfo(ftpClient, taskID, fileName, filePath, size, offset, progressRow, viewWhenComplete) {
	this.ftpClient = ftpClient;
	this.taskID = Number(taskID);
	this.fileName = String(fileName);
	this.filePath = String(filePath);
	this.size = Number(size);
	this.offset = Number(offset);
	this.progressRow = progressRow;
	this.viewWhenComplete = viewWhenComplete;
}
